/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ShowInOut.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
var gsio_tree_view;
var gMyAddr;
var gColumns=new Object();

var gHeaderParser = Components.classes["@mozilla.org/messenger/headerparser;1"].
        getService(Components.interfaces.nsIMsgHeaderParser);
var gPrefs = Components.classes["@mozilla.org/preferences;1"].
    getService(Components.interfaces.nsIPref).getBranch("extensions.showInOut.");
var gMessenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
    QueryInterface(Components.interfaces.nsIMessenger);
var gAserv=Components.classes["@mozilla.org/atom-service;1"].
          getService(Components.interfaces.nsIAtomService);

var gTB3;

var gPrefixType;
var gInTextPrefix='';
var gOutTextPrefix='';

var MSG_FOLDER_FLAG_TRASH = 0x0100;
var MSG_FOLDER_FLAG_JUNK = 0x40000000;

var ident=Date.now()-Date.parse('Sep 14, 2008');

function sio_searchTerm(text, searchTermsArray) {
  if (gSearchInput.searchMode == 99)
  {
    // Sender is search string
    term = gSearchSession.createTerm();
    value = term.value;
    value.str = text;
    term.value = value;
    term.attrib = nsMsgSearchAttrib.Sender;
    term.op = nsMsgSearchOp.Contains;
    term.booleanAnd = true;
//    term.beginsGrouping=true;
    searchTermsArray.AppendElement(term);

    var i=0;
    //OR sender is me
    for (var email in gMyAddr) {
      term = gSearchSession.createTerm();
      value = term.value;
      value.str = email;
      term.value = value;
      term.attrib = nsMsgSearchAttrib.Sender;
      term.op = nsMsgSearchOp.Contains;
      term.booleanAnd = false;
      if (!i) term.beginsGrouping=true;
      searchTermsArray.AppendElement(term);
      //OR
      i++;
    }
    // AND Recipient is search string
    term = gSearchSession.createTerm();
    value = term.value;
    value.str = text;
    term.value = value;
    term.attrib = nsMsgSearchAttrib.To;
    term.op = nsMsgSearchOp.Contains;
    term.booleanAnd = true;
    term.endsGrouping=true;
    searchTermsArray.AppendElement(term);
  }
}

var sio_config =
{
/*
 *  Find all email addresses, which count as mine
 */
  getMyEmails: function () {
    gMyAddr=new Object;
    var accountMgr=
      Components.classes["@mozilla.org/messenger/account-manager;1"].
        getService(Components.interfaces.nsIMsgAccountManager);
    var allAccounts=accountMgr.accounts;
    var accountsCount = allAccounts.Count();
    for (var i = 0; i < accountsCount; i++) {
      var account = allAccounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
      var allIdentities=account.identities;
      var identitiesCount = allIdentities.Count();
      for (var j = 0; j < identitiesCount; j++) {
        var identity = allIdentities.QueryElementAt(j, Components.interfaces.nsIMsgIdentity);
        if (identity.email) { //see mail from "Simon Arthur"
          var email=identity.email.toLowerCase();
          if (gMyAddr[email]===undefined)
            gMyAddr[email]=1;
  //dump(identity.email+' stored as '+email+'\n');
        }
      }
    }
  // and get extra email addresses
    try {
      var aa = gPrefs.getCharPref("AdditionalAddresses").split(',');
      for (var i=0; i<aa.length; i++) {
        var email=aa[i].toLowerCase();  // .trim()
        email=email.replace(/\s/g, ''); // besser .trim(), wenn verfgbar
        if (email && gMyAddr[email]===undefined)
          gMyAddr[email]=1;
      }
    } catch(e) { }
//for (email in gMyAddr) dump(email+'\n');
    sio_cache.clear(null);
  },

  observe: function(aSubject, aTopic, aData)
  {
    switch (aTopic)
    {
      case "nsPref:changed":
//dump('pref changed: '+aData+'\n');
//aSubject ist ein nsIPrefBranch(2), aData ist die Preference
        if (aData=='AdditionalAddresses')
          this.getMyEmails();
        else if (aData=='PrefixType')
          try { gPrefixType = gPrefs.getCharPref("PrefixType"); } catch(e) { gPrefixType='none'; }
        else if (aData=='InTextPrefix')
          try { gInTextPrefix = gPrefs.getCharPref("InTextPrefix"); } catch(e) { gInTextPrefix=''; }
        else if (aData=='OutTextPrefix')
          try { gOutTextPrefix = gPrefs.getCharPref("OutTextPrefix"); } catch(e) { gOutTextPrefix=''; }
        break;
    }
  }
}

function sio_extractName(email, received, isJunk) {
  var addrs={};
  var names={};
  var full={};
  var count=0;
  count=gHeaderParser.parseHeadersWithArray( email, addrs, names, full, count);
  var show='';
  if (received=='in') {
    if (isJunk)
      show=full.value[0];
    else {
      show=names.value[0];
      if (!show) show=addrs.value[0];
    }
    if (show.charAt(0)=='"' && show.charAt(show.length-1)=='"') show=show.substr(1,show.length-2);
  } else {
    for (var i=0; i<count; i++) {
      s=names.value[i];
      if (!s) s=addrs.value[i];
      if (count>1 && s.indexOf(',')>=0 && s.charAt(0)!='"'&& s.charAt(0)!="'") s='"'+s+'"';
      if (show) show+=', ';
      show+=s;
    }
  }
  return show;
}

var sio_cache = {
  addr_cache: null,
  data_cache: null,
  length: 0,
  lastFolder: null,
  clear: function(folder) {
    this.data_cache = new Object;
    this.addr_cache = new Object;
    this.lastFolder=folder?folder.URI:'';
    this.length=0;
//dump('SIO-'+ident+': cache cleared\n');
  },
  cache: function(messageURI, msgHdr) {
    if (this.data_cache[messageURI] !== undefined) return;  //already cached
//if (this.length==0) dump('SIO-'+ident+': start filling cache\n');

    if (!msgHdr)
      msgHdr=gMessenger.msgHdrFromURI(messageURI);
//dump(messageURI+'=>'+msgHdr.folder.URI+'\n');
    // extract just the mail address from the author and compare to the list of 'my' Addresses
    if (gTB3<3)
      var author = gHeaderParser.extractHeaderAddressMailboxes(null, msgHdr.author).toLowerCase();
    else
      var author = gHeaderParser.extractHeaderAddressMailboxes(msgHdr.author).toLowerCase();

    var received=gMyAddr[author]===undefined?'in':'out';
//dump('Author='+author+' received='+received+'\n');
    var newsgroup=msgHdr.folder.URI.substr(0,5)=='news:';
  //test: from
  //http://developer.mozilla.org/en/docs/Extensions:Thunderbird:customDBHeaders_Preference
  //  needs: user_pref( "mailnews.customDBHeaders", "Return-Path Received");
  /*
    var rp = msgHdr.getStringProperty("return-path"); //klappt nicht! (ist nicht in .msf)
    dump("Return-Path: " + rp + "\n");
    var r = msgHdr.getStringProperty("received"); //klappt
    dump("Received: " + r + "\n");
  */

    this.data_cache[messageURI]=received;

    // Add keyword 'in' or 'out' to message
    // these are automagically transformed to properties
    // 'kw-in' and 'kw-out' on all cells
    // This would be a nice way to set properties on cells and
    // would render the factory approach lower down unnecessary.
    // Unfortunately this does not work reliable, probably related to the
    // way keywords (aka tags) are store in imap folders
    // Probably will work if set at another time (e.g. after message download)
  /*
    var keywords=msgHdr.getStringProperty('keywords');
    var tags=keywords.split(' ');
    var haveProp=false;
    for (var i=0; i<tags.length; i++) {
      if (tags[i]=='in' || tags[i]=='out') { haveProp=true; break; }
    }
    if (!haveProp)
      msgHdr.setStringProperty('keywords', (keywords?keywords+' '+received:received));
  */

    // mark message as junk, if its in a folder, marked as junk (thanks to Martijn Coppoolse for this hint)
    // or if the message has a nonzero junkscore
    var isJunk = msgHdr.folder.getFlag(MSG_FOLDER_FLAG_JUNK);
    if (!isJunk) {
      var junkScore = msgHdr.getStringProperty("junkscore");
      // according to SelectedMessagesAreJunk() in mailWindowOverlay.js:
      isJunk =  ((junkScore != "") && (junkScore != "0"));
      // but i think its:
      //var isJunk =  ((junkScore === "") || (junkScore != "0"));
    }
    this.addr_cache[messageURI] = received=='in' || newsgroup ?
        gInTextPrefix+sio_extractName(msgHdr.mime2DecodedAuthor, received, isJunk)  :
        gOutTextPrefix+sio_extractName(msgHdr.mime2DecodedRecipients, received, false) ;
    this.length+=1;
  },
  received: function(messageURI) { return this.data_cache[messageURI]; },
  addr: function(messageURI)     { return this.addr_cache[messageURI]; },

  OnItemEvent: function(folder, event) { // ( nsIMsgFolder item , nsIAtom event )
//dump('SIO-'+ident+': '+folder.folderURL+' (last: '+this.lastFolder+') '+event+' cache: '+this.length+'\n');
    //z.B. 'FolderLoaded', 'DeleteOrMoveMsgCompleted', 'CompactCompleted'
    if (event=='CompactCompleted' || event=='FolderLoaded' && folder.flags&MSG_FOLDER_FLAG_TRASH) {
      // there is no event, when the Trash is emptied => clear cache, when trash folder gets loaded
      this.clear(folder);
    }
  }
}

function sio_init() {
  var app = Components.classes["@mozilla.org/xre/app-info;1"].
         getService(Components.interfaces.nsIXULAppInfo);
//dump(app.name+' '+app.version+'\n');
  //gTB3: 0=TB2, 1=TB3a1, 2=TB3a2,a3,SM2a1; 3=TB3B1,SM2a2
  if (app.name=='Thunderbird')
    gTB3=app.version.substr(0,1)!='3'?0:app.version.substr(2,3)=='0a1'?1:app.version.substr(2,3)=='0b1'?3:2; //3.0a1, 3.0a2pre
  else if (app.name=='SeaMonkey')
    gTB3=app.version.substr(2,3)=='0a1'?2:3;

  sio_cache.clear(null);

/*
 *  Install Listener
 */
  var session=
    Components.classes["@mozilla.org/messenger/services/session;1"].
      getService(Components.interfaces.nsIMsgMailSession);
  session.AddFolderListener(sio_cache, 128); //folderListenerNotifyFlagValue  	 event

/*
 *  Find all email addresses, which count as mine
 */
  sio_config.getMyEmails();

  try { gPrefixType = gPrefs.getCharPref("PrefixType"); } catch(e) { gPrefixType='none'; }
  if (gPrefixType=='text') {
    try { gInTextPrefix = gPrefs.getCharPref("InTextPrefix"); } catch(e) { gInTextPrefix=''; }
    try { gOutTextPrefix = gPrefs.getCharPref("OutTextPrefix"); } catch(e) { gOutTextPrefix=''; }
  }

  // find possible columns  (but how to determine, if its a standard col, containing strings!)
  var col=document.getElementById('threadCols').childNodes;
  var label;
  for (var i=0; i<col.length; i++) {
    if (col[i].tagName=='treecol' && (label=col[i].getAttribute('label')) && !col[i].getAttribute('added'))
      gColumns[col[i].id]=label;
  }

  //see http://developer.mozilla.org/en/docs/Extensions:Thunderbird:Creating_a_Custom_Column
  // this is a noop (since "MsgCreateDBView" is not available),
  // if the custom column mechanism is not available (as in TB<2.0)
  var ObserverService = Components.classes["@mozilla.org/observer-service;1"].
    getService(Components.interfaces.nsIObserverService);
  ObserverService.addObserver(sio_CreateDbObserver, "MsgCreateDBView", false);

  //since 3.0a2 the observer is not called at app start
  // (or the addObserver is too late)
  ObserverService.notifyObservers(null, "MsgCreateDBView", null);

  //add a preferences observer
  gPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2).addObserver("", sio_config, false);
  // would be nice to have a 'identity changed' observer

  //extend the quick search toolbar
  // currently, its only a search over To: and From:
  var qs=document.getElementById("quick-search-menupopup");
  if (qs) { //not available in SM2.0a2
    var mi=document.createElement('menuitem');
    mi.setAttribute('type', 'radio');
    var code=99;  // probably should find an unused number!
    mi.setAttribute('value', code);
    try {
      var strings=Components.classes["@mozilla.org/intl/stringbundle;1"]
        .getService(Components.interfaces.nsIStringBundleService)
        .createBundle('chrome://showinout/locale/showinout.properties');
      mi.setAttribute('label', strings.GetStringFromName('gegenseite'));
    } catch(e) { mi.setAttribute('label', 'Correspondent'); }
    mi.setAttribute('oncommand', "changeQuickSearchMode(this)");
    qs.insertBefore(mi, qs.firstChild);

    var js=window.createSearchTerms; // in messenger/content/messenger/searchBar.js
    if (js) {
//alert('ORIG='+js.toSource());
      var jsneu=js.toSource().replace(/(\s*if\s*\(\s*gSearchInput\.searchMode\s*==)/,
        'if (gSearchInput.searchMode == '+code+') sio_searchTerm(termList[i], searchTermsArray); $1');
      if (jsneu != js.toSource()) {
        jsneu=jsneu.replace(/function\s*createSearchTerms\(\s*\)/, '');
//alert('CHANGED='+jsneu);
        window.createSearchTerms=new Function(jsneu);
//alert('NOW='+window.createSearchTerms);
      }
    }
  }
}


//------------------------------------------------------------------------------------

/*  from mailnews/base/public/nsIMsgCustomColumnHandler.idl
       When implementing a js custom column handler (of type nsITreeView) you must implement the following
       functions:
       1. isEditable
       2. GetCellProperties
       3. GetImageSrc
       4. GetCellText
       5. CycleCell
       6. GetSortStringForRow
       7. GetSortLongForRow
       8. isString

       You can, at your option, implement (No, you must! (gg))
       9.  GetRowProperties.
    (also see mailnews/base/src/nsMsgDBView.cpp)

  GetRowProperties is called for columns, which are not visible, but
  GetCellProperties is called only for visible columns!
*/

//--------------------------------------
var sio_columnHandler_inoutcol = {
  getCellText:         function(row, col) {
  },
  getCellProperties:   function(row, col, properties) {
//dump('Get cel inoutcol\n');
    //probably should use:
    //var key = gDBView.getKeyAt(row);
    //var hdr = gDBView.db.GetMsgHdrForKey(key);
      var messageURI = gDBView.getURIForViewIndex(row);
      sio_cache.cache(messageURI);
      var received=sio_cache.received(messageURI);
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        properties.AppendElement(gAserv.getAtom(received));
      }
  },
  getRowProperties:    function(row, properties) {
    //this is done in the sio_inoutaddresscol
  },
  getImageSrc:         function(row, col) {
    return null;
  },

  //not really called !?
 	isEditable:          function(row, col) {
    return false;
  },
 	cycleCell:           function(row, col) {
  },

  getSortStringForRow: function(hdr) {
//dump('called sort strin in inoutcol\n');
    return '';
  },
  getSortLongForRow:   function(hdr) {
//dump('called sort long in inoutcol\n');
    var messageURI=hdr.folder.getUriForMsg(hdr);
    sio_cache.cache(messageURI, hdr);
    if (sio_cache.received(messageURI)=='in') return 0;
    else return 1;
  },
  isString:            function() {
    return false;
  }

}

//--------------------------------------
var sio_columnHandler_inoutaddresscol = {
  getCellText:         function(row, col) {
    var messageURI = gDBView.getURIForViewIndex(row);
    sio_cache.cache(messageURI);
//should probably use: FetchAuthor(msgHdr);
//should probably use: FetchRecipients(msgHdr);
//dump('Get cell inoutaddresscol row='+row+' URI= '+messageURI+' returned '+sio_cache.addr(messageURI)+'\n');
    return sio_cache.addr(messageURI);
  },
  getCellProperties:   function(row, col, properties) {
//dump('Get cell inoutaddresscol row='+row+'\n');
      var messageURI = gDBView.getURIForViewIndex(row);
      sio_cache.cache(messageURI);
      var received=sio_cache.received(messageURI);
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        properties.AppendElement(gAserv.getAtom(received));
      }
  },
  getRowProperties:    function(row, properties) {
//dump('Get row inoutaddresscol index='+row+'\n');
    var messageURI = gDBView.getURIForViewIndex(row);
    sio_cache.cache(messageURI);
    var received=sio_cache.received(messageURI);
      //properties already defined:
      //    ???
      //  appending [in|out]
    if (received!==null) {
      properties.AppendElement(gAserv.getAtom(received));
/*
      //try to set this property an _all_ cells in the row!
      var cols=document.getElementById('threadTree').columns;
//dump(cols+'\n');
      var col=cols.getFirstColumn();
      while (col) {
//dump(col.id+'\n');
        var props = Components.classes["@mozilla.org/supports-array;1"].createInstance().
            QueryInterface(Components.interfaces.nsISupportsArray);
        gDBView.getCellProperties(row, col, props);
        props.AppendElement(gAserv.getAtom(received));
        col=col.getNext();
      }
*/
    }
  },
  getImageSrc:         function(row, col) {
/*
    if (col.id=='sio_inoutaddressCol') {
      // image inserted in front of the text, returned in getCellText
      return "chrome://showInOut/skin/out.png";
    }
*/
    return null;
  },

  //not really called !?
 	isEditable:          function(row, col) {
    return false;
  },
 	cycleCell:           function(row, col) {
  },

  getSortStringForRow: function(hdr) {
//dump('called sort string in inoutaddresscol\n');
    var messageURI=hdr.folder.getUriForMsg(hdr);
    sio_cache.cache(messageURI, hdr);
    var s=sio_cache.addr(messageURI);
    if (s.substr(0,1)=='"') s=s.substr(1);
    return s;
  },
  getSortLongForRow:   function(hdr) {
//dump('called sort long in inoutaddresscol\n');
  },
  isString:            function() {
    return true;
  }

}

//------------------------------------------------------------------------------------
    // Factory for other column handlers
    // These column handlers replace the original handlers and
    // are calling the original handlers to get the correct values. But
    // to do this the custom column handler must be temporarily removed,
    // or we will be called recursivly. Fortunately, removing and adding
    // handlers is a lightweight operation
    // All this only to set the in/out property in getCellProperties()!
    /// The original code is in mailnews/base/src/nsMsgDBView.cpp
var sio_columnHandler_factory = 'var sio_columnHandler = {'+
'  getCellText: function(row, col) {'+
'    gDBView.removeColumnHandler("theCol");'+
'    var val=gDBView.getCellText(row, col);'+
'    gDBView.addColumnHandler("theCol", this);'+
'    return val;'+
'  },'+
'  getCellProperties: function(row, col, properties) {'+
//original function already had set standard properties, just add our property
'    var messageURI = gDBView.getURIForViewIndex(row);'+
'    sio_cache.cache(messageURI);'+
'    var received=sio_cache.received(messageURI);'+
'    if (received!==null) properties.AppendElement(gAserv.getAtom(received));'+
'  },'+
'  getRowProperties: function(row, properties) {'+
//original function already had set standard properties
'  },'+
'  getImageSrc: function(row, col) {'+
//original function never returns something
'    return;'+
'  },'+
'  isEditable: function(row, col) {'+
//original function always returns false!
'    return false;'+
'  },'+
'  cycleCell: function(row, col) {'+
//original function does nothing for cells, containing text
'    return ;'+
'  }'+
'}';
//getSortStringForRow, getSortLongForRow and isString need not be
//  implemented for standard columns since they are not called

//------------------------------------------------------------------------------------

var sio_CreateDbObserver = {
  // Components.interfaces.nsIObserver

  observe: function(aMsgFolder, aTopic, aData)
  {
//dump('gDBView '+gDBView+'\n');
    if (typeof gDBView!='undefined' && gDBView) { //check mit typeof, da gelegentlich undefined!
      gDBView.addColumnHandler("sio_inoutCol", sio_columnHandler_inoutcol);
      gDBView.addColumnHandler("sio_inoutaddressCol", sio_columnHandler_inoutaddresscol);

      // define column_handlers for some other columns. This allows me to set the in/out property
      // ONLY define _standard_ columns with _string_ content!!!
      // column Names: subjectCol dateCol senderCol recipientCol sizeCol locationCol accountCol
      try {
        cols = gPrefs.getCharPref("Columns").split(',');
        //TODO: be sure, its only called for standard columns containing text
        //      (the factory assumes standard columns!)
        for (var i=0; i<cols.length; i++) {
          var col=cols[i].replace(/\s/g, ''); // besser .trim(), wenn verfgbar
          if (gColumns.hasOwnProperty(col)) {
            var handler_text=sio_columnHandler_factory;
            eval(handler_text.replace('theCol', col, 'g'));
            gDBView.addColumnHandler(col, sio_columnHandler);
          }
        }
      } catch(e) { }
    }
  }
}

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", sio_init, false);
//setTimeout(sio_init, 1000);


function dumpTree() {
  var tree=document.getElementById('threadTree');
//  dump('DOM: '+tree.tagName+'\n');
  var rows=tree.firstChild.nextSibling; //treechildren, nicht xul:treerows!!!
  //rows.firstChild: ex. nicht!
  //rows.childNodes.length=0 !!!
}

function dumpProps(row, col, properties) {
  for (var i=0; i<properties.Count(); i++) {
    var prop;
    prop=properties.GetElementAt(i).QueryInterface(Components.interfaces.nsIAtom);
    dump('prop ('+row+','+col.id+'): '+prop.toString()+"\n");
  }
}

